/**
 * <p>TSpeichert die Attribute einer Linie.</p>
 * @author Alexander Pacnik, Johannes Wechsler
 * @version 2.0
 */

public class LineInfo extends ObjectInfo
{
//*Field Detail***************************************************************//

   /** Speichert die eindeutige ID einer Linie.*/
   private int ID;

//*Constructor Detail*********************************************************//

   /** Setzt beim initilaisieren der Linie die ID.
    *  @param Ist die eindeutige ID die bergeben wird.
    *  */
   public LineInfo(int ID)
   {
      if ((ID>0) && (ID<5))
      this.ID = ID;
      else System.out.println("ERROR: Value for ID needs to be between 1 to 4");
   }

//*Method Detail**************************************************************//

   public void setID(int ID)
   { this.ID = ID; }

   public int getID()
   { return this.ID; }
}
