/**
 * <p>Speichert ob der Spieler ein Torwart ist (golie), Teamzugehrigkeit
 * (team) und die Spielernummer.</p>
 * @author Alexander Pacnik, Johannes Wechsler
 * @version 2.0
 */

public class PlayerInfo extends DynamicObjectInfo
{
//*Field Detail***************************************************************//

   /** Ist der Spieler der Torwart?*/
   private boolean goalie;

   /** Zu welchem team gehrt der Spieler?*/
   private int team;

   /** Die Spielernummer*/
   private int ID;

//*Constructor Detail*********************************************************//

   /** Setzt die default Werte.*/
   public PlayerInfo()
   {
      this.team = -1000;
      this.ID = -1000;
      this.goalie = false;
   }

//*Method Detail**************************************************************//

   public void setID(int ID)
   { this.ID = ID; }

   public void setTeam(int team)
   { this.team = team; }

   public void setGoalie(boolean goalie)
   { this.goalie = goalie; }

   public int getID()
   { return this.ID; }

   public int getTeam()
   { return this.team; }

   public boolean getGoalie()
   { return this.goalie; }
}