/**
 * <p>The class defines the characteristics of a line: lineId. In addition, a line has the
 * following properties:  distance, direction.</p>
 * @author Alexander Pacnik, Johannes Wechsler
 * @version 1.0
 */

public class LineInfo extends ObjectInfo
{
   /** flag ID*/
   protected int ID;

   /** Constructor */
   public LineInfo(int ID, double direction, int time)
   {
      this.ID = ID;
      this.direction = direction;
      this.time = time;
   }

//*get-methods****************************************************************//

   /** get flag ID*/
   public int getID()
   { return this.ID; }

   /** get flag direction*/
   public double getDirection()
   { return this.direction; }

   /** get flag time*/
   public int getTime()
   { return this.time; }

//*set-methods****************************************************************//

   /** set flag direction*/
   public void setDirection(double direction)
   { this.direction = direction; }

   /** set flag time*/
   public void setTime(int time)
   { this.time = time; }
}
