//ToDos:
//Methoden ownPlayerCalculation und ballCalculation ueberpruefen
//Zahlreiche Methoden implementieren

public class SParser
{
   WorldModel worldModel = new WorldModel();

   //Call: sParser.hearCalculation(time)
   public void hearCalculation(int time)
   { worldModel.setCurrentTime(time); }

   //Call: sParser.hearCalculation(time, playMode)
   public void hearCalculation(int time, int playMode)
   {
      worldModel.setCurrentTime(time);
      worldModel.setPlayMode(playMode);
   }

   //Call: sParser.hearCalculation(time, ballPosX, ballPosY)
   public void hearCalculation(int time, double ballPosX, double ballPosY)
   {
      worldModel.setBallTime(time);
      worldModel.setCurrentTime(time);
      worldModel.setBallPosX(ballPosX);
      worldModel.setBallPosY(ballPosY);
   }

   //Call: sParser.scoreCalculation(time, ourScore, theirScore)
   public void scoreCalculation(int time, int ourScore, int theirScore)
   {
      worldModel.setCurrentTime(time);
      worldModel.setOurScore(ourScore);
      worldModel.setTheirScore(theirScore);
   }

   //Call: sParser.initCalculation(side, number, playMode)
   public void initCalculation(int side, int number, int playMode)
   {
      worldModel.setSide(side);
      worldModel.setPlayMode(playMode);
      worldModel.setNumber(number);
   }

   //Call: sParser.bodyCalculation(time, viewModeQuality, viewModeRange, stamina, effort, amoungOfSpeed, directionOfSpeed, headAngle, kickCount, dashCount, turnCount, sayCount, turnNeckCount, catchCount, moveCount, changeViewCount);
   public void bodyCalculation(int time, int viewModeQuality, int viewModeRange, int stamina, int effort, double amountOfSpeed, double directionOfSpeed, double headAngle, int kickCount, int dashCount, int turnCount, int sayCount, int turnNeckCount, int catchCount, int moveCount, int changeViewCount)
   {
      System.out.println("Parser:");
      System.out.println("viewModeQuality " +viewModeQuality);
      System.out.println("viewModeRange " +viewModeRange);
      System.out.println("stamina " +stamina);
      System.out.println("effort " +effort);
      System.out.println("amountOfSpeed " +amountOfSpeed);
      System.out.println("directionOfSpeed " +directionOfSpeed);
      System.out.println("headAngle " +headAngle);
      System.out.println("kickCount " +kickCount);
      System.out.println("dashCount " +dashCount);
      System.out.println("turnCount " +turnCount);
      System.out.println("sayCount " +sayCount);
      System.out.println("turnNeckCount " +turnNeckCount);
      System.out.println("catchCount " +catchCount);
      System.out.println("moveCount " +moveCount);
      System.out.println("changeViewCount " +changeViewCount);

      worldModel.setViewModeQuality(viewModeQuality);
      worldModel.setViewModeRange(viewModeRange);
      worldModel.setStamina(stamina);
      worldModel.setEffort(effort);
      worldModel.setAmountOfSpeed(amountOfSpeed);
      worldModel.setDirectionOfSpeed(directionOfSpeed);
      worldModel.setHeadAngle(headAngle);
      worldModel.setKickCount(kickCount);
      worldModel.setDashCount(dashCount);
      worldModel.setTurnCount(turnCount);
      worldModel.setSayCount(sayCount);
      worldModel.setTurnNeckCount(turnNeckCount);
      worldModel.setCatchCount(catchCount);
      worldModel.setMoveCount(moveCount);
      worldModel.setChangeViewCount(changeViewCount);
      worldModel.setCurrentTime(time);
   }

   //Call: SParser.flagCalculation(ID, distance, direction, time)
   public void flagCalculation(int ID, double distance, double direction, int time)
   { //FlagInfo.setFlag(ID, distance, direction, time);
   }

    //Call: SParser.lineCalculation(ID, direction)
    public void lineCalculation(int ID, double direction){}

   //Call: SParser.ballCalculation(distance, direction, distChange, dirChange, time)
   public void ballCalculation(double distance, double direction, double distChange, double dirChange, int time)
   {
      double posX = -1000;
      double posY = -1000;

      double viewDirection = worldModel.getOwnPlayerViewDirection();
      double realDirection = viewDirection + direction;
      posX = distance * Math.cos(realDirection);
      posY = distance * Math.sin(realDirection);

      //Methodenaufruf: Aktualisieren der Werte
      if (posX != -1000)
      { worldModel.setBallPosX(posX); }
      if (posY != -1000)
      { worldModel.setBallPosY(posY); }

      worldModel.setCurrentTime(time);
      worldModel.setBallTime(time);
   }

   //Call: SParser.flagCapitalizedCalculation(distance, direction, time)
   public void flagCapitalizedCalculation(double distance, double direction, int time){}

   //Call: SParser.goalWithoutNameCalculation(distance, direction, time)
   public void goalCapitalizedCalculation(double distance, double direction, int time){}

   //Call: SParser.playerCalculation(team, ID, goalie, distance, direction, distChange, dirChange, time)
   public void playerCalculation(int team, int ID, boolean goalie, double distance, double direction, double distChange, double dirChange, int time){}

   //Call: SParser.playerCalculation(team, ID, goalie, distance, direction, distChange, dirChange, time)
   public void playerCapitalizedCalculation(int team, int ID, boolean goalie, double distance, double direction, double distChange, double dirChange, int time){}

//*ownPlayerCalculation()*****************************************************//

   public void ownPlayerCalculation()
   {
      //aktuelle Linie finden
      LineInfo lineTmp        = null;
      FlagInfo flagTmp        = null;
      FlagInfo flagTmpNear    = null;                                           //2. nchste Fahne fr den Fall, dass keine Linie verfgbar
      FlagInfo flagTmpNearest = null;                                           //nchste Fahne
      double   absDirection   = -1000;                                          //absoluter Blickwinkel ausgehend von einer Linie
      double   realDirection  = -1000;                                          //absolute Richtung, in der sich die nchste Fahne befindet
      double   posX           = -1000;                                          //absolute X-Koordinate
      double   posY           = -1000;                                          //absolute Y-Koordinate
      int side                = worldModel.getSide();                           //Seite: links=1, rechts=2

      //Fahnen
      //nchste und zweitnchste Fahnen bestimmen, die die aktuelle Zeit aufweisen
      for (int ID = 1; ID < 56; ID ++)
      {
         if (worldModel.getFlagTime(ID) == worldModel.getCurrentTime())         //Fahnen auf zeitliche Aktualitt berprfen
         { flagTmp = worldModel.getFlag(ID);}                                   //Fahne merken
         if ((flagTmp != null) && (flagTmp.getID() <= 48))                      //Nur Fahnen 1 - 48 verwenden: auessere Fahnen
         {
            if ((flagTmpNearest != null) && (flagTmpNear != null))              //wenn schon zwei nahe Fahnen exisitieren: berprfen ob neue nher
            {
               if (flagTmp.getDistance() < flagTmpNearest.getDistance())
               { flagTmpNearest = flagTmp; }
               if ((flagTmp.getDistance() >= flagTmpNearest.getDistance()) && (flagTmp.getDistance() < flagTmpNear.getDistance()))
               { flagTmpNear = flagTmp; }
            }
            if ((flagTmpNearest != null) && (flagTmpNear == null))              //wenn nur eine nahe Fahne exisitiert: berprfen ob neue nher und 2.nchste neu merken
            {
               if (flagTmp.getDistance() < flagTmpNearest.getDistance())
               {
                  flagTmpNearest = flagTmp;
                  flagTmpNear = flagTmp;
               }
               if (flagTmp.getDistance() >= flagTmpNearest.getDistance())
               { flagTmpNear = flagTmp; }
            }
            if ((flagTmpNearest == null))                                       //wenn keine nahe Fahne existiert: neue Fahne als nchste merken
            { flagTmpNearest = flagTmp;}
         }
      }

      //Linien
      //beliebige Linie bestimmen
      if((worldModel.getLineTime(2) == worldModel.getCurrentTime()) && (worldModel.getLineDirection(2) != -1000))              //rechts
      { lineTmp = worldModel.getLine(2); }
      if((worldModel.getLineTime(4) == worldModel.getCurrentTime()) && (worldModel.getLineDirection(4) != -1000))              //links
      { lineTmp = worldModel.getLine(4); }
      if((worldModel.getLineTime(3) == worldModel.getCurrentTime()) && (worldModel.getLineDirection(3) != -1000))              //unten
      { lineTmp = worldModel.getLine(3); }
      if((worldModel.getLineTime(1) == worldModel.getCurrentTime()) && (worldModel.getLineDirection(1) != -1000))              //oben
      { lineTmp = worldModel.getLine(1); }

      //wenn eine Linie mit der aktuellen Zeit und richtigem Winkel gefunden wurde
      if((lineTmp != null) && (lineTmp.getTime() == worldModel.getCurrentTime()) && (lineTmp.getDirection() != -1000))                                                       //falls eine Linie gesehen wird
      {
         double relDirection = lineTmp.getDirection();
         int ID = lineTmp.getID();

         if ( side == 1)                                                        //Spielrichtung: von links nach rechts
         {
            if (ID == 1)                                                        //obere Linie
            { absDirection = relDirection - 90; }
            if (ID == 2)                                                        //rechte Linie
            { absDirection = relDirection;}
            if (ID == 3)                                                        //untere Linie
            { absDirection = relDirection + 90; }
            if (ID == 4)                                                        //linke Linie
            {
               if (relDirection >= 0)
               { absDirection = relDirection - 180; }
               if (relDirection < 0)
               { absDirection = relDirection + 180; }
            }
         }
         if (side == 2)                                                         //Spielrichtung: von rechts nach links
         {
            if (ID == 1)                                                        //obere Linie
            { absDirection = relDirection + 90; }
            if (ID == 2)                                                        //rechte Linie
            {
               if (relDirection >= 0)
               { absDirection = relDirection - 180; }
               if (relDirection < 0)
               { absDirection = relDirection + 180; }
            }
            if (ID == 3)                                                        //untere Linie
            { absDirection = relDirection - 90; }
            if (ID == 4)                                                        //linke Linie
            { absDirection = relDirection; }
         }
      }

      //1. Fall: Eine Linie und eine Fahne vorhanden
      if ((lineTmp!= null) && (flagTmpNearest != null))
      {
         //Zeit und Direction stimmen
         if ((flagTmpNearest.getDirection() != 1000) && (lineTmp.getDirection() != -1000) && (flagTmpNearest.getTime() == worldModel.getCurrentTime()) && (lineTmp.getTime() == worldModel.getCurrentTime()))
         {
            realDirection = absDirection + flagTmpNearest.getDirection();
            posX = flagTmpNearest.getDistance() * Math.cos(realDirection);
            posY = flagTmpNearest.getDistance() * Math.sin(realDirection);
         }
      }

      //2. Fall: Keine Linie, aber zwei Fahnen vorhanden
      if ((lineTmp == null) || (lineTmp.getDirection() == -1000) || (lineTmp.getTime() != worldModel.getCurrentTime()))
      {
         if ((flagTmpNearest != null) && (flagTmpNearest.getDirection() != 1000) && (flagTmpNearest.getTime() == worldModel.getCurrentTime())  && (flagTmpNear != null) && (flagTmpNear.getDirection() != 1000) && (flagTmpNear.getTime() == worldModel.getCurrentTime()))
         {
            int IDTmp = flagTmpNearest.getID();
            double relDirection = flagTmpNearest.getDirection();

            if (side==1)                                                                      //Spielrichtung: von links nach rechts
            {
               if ( ((1 <= IDTmp) && (IDTmp <= 11)) || (IDTmp == 38))                         //obere Fahne
               { absDirection = relDirection - 90; }
               if ( ((12 <= IDTmp) && (IDTmp <= 18)) || ((39 <= IDTmp) && (IDTmp <= 43)))     //rechte Fahne
               { absDirection = relDirection;}
               if ( ((19 <= IDTmp) && (IDTmp <= 29)) || (IDTmp == 44))                        //untere Fahne
               { absDirection = relDirection + 90; }
               if ( ((30 <= IDTmp) && (IDTmp <= 37)) || ((45 <= IDTmp) && (IDTmp <= 48)))     //linke Fahne
               {
                  if (relDirection >= 0)
                  { absDirection = relDirection - 180; }
                  if (relDirection < 0)
                  { absDirection = relDirection + 180; }
               }
            }
            if (side==2)                                                                      //Spielrichtung: von rechts nach links
            {
               if ( ((1 <= IDTmp) && (IDTmp <= 11)) || (IDTmp == 38))                         //obere Fahne
               { absDirection = relDirection + 90; }
               if ( ((12 <= IDTmp) && (IDTmp <= 18)) || ((39 <= IDTmp) && (IDTmp <= 43)))     //rechte Fahne
               {
                   if (relDirection >= 0)
                   { absDirection = relDirection - 180; }
                   if (relDirection < 0)
                   { absDirection = relDirection + 180; }
               }
               if ( ((19 <= IDTmp) && (IDTmp <= 29)) || (IDTmp == 44))                        //untere Fahne
               { absDirection = relDirection - 90; }
               if ( ((30 <= IDTmp) && (IDTmp <= 37)) || ((45 <= IDTmp) && (IDTmp <= 48)))     //linke Fahne
               { absDirection = relDirection; }
            }
         }
      }

      //Methodenaufruf: Aktualisieren der absoluten X und Y Koordinaten und der absoluten Blickrichtung
      if (posX != -1000)
      { worldModel.setOwnPlayerPosX(posX); }
      if (posY != -1000)
      { worldModel.setOwnPlayerPosY(posY); }
      if (realDirection != -1000)
      { worldModel.setOwnPlayerViewDirection(realDirection); }
   }
}





