/*******************************************************************************
*   public class WorldModel                                                    *
*                                                                              *
*   The class offers acessor methods for the classes:                          *
*   BallInfo, PlayerInfo, playerArray[0]Info, LineInfo and FlagInfo                 *
*   The offered methods are listed below.                                      *
*                                                                              *
*   @author Alexander Pacnik, Johannes Wechsler                                *
*   @revised by                                                                *
*   @version 1.0                                                               *
*******************************************************************************/

//ToDos:
//1. Genaue Koordinaten von Toren und Strafraum
//2. Ball speichern
//3. Torwart Methoden implementieren

public class WorldModel
{
   //Initialisierungen
   PlayerTable playerTable = new PlayerTable();
   FlagTable flagTable     = new FlagTable();
   LineTable lineTable     = new LineTable();
   BallTable ballTable     = new BallTable();

  //Goalie fuer Holger
   public boolean getCatchBan()
   { return false; }

   public void setCatchBan(boolean goalieHasCatched)
   {}

   //PlayModeTable
   public void setOurScore(int ourScore)
   { PlayModeTable.setOurScore(ourScore); }

   public void setTheirScore(int theirScore)
   { PlayModeTable.setTheirScore(theirScore); }

   public void setCurrentTime(int currentTime)
   { PlayModeTable.setCurrentTime(currentTime); }

   public void setPlayMode (int playMode)
   { PlayModeTable.setPlayMode(playMode); }

   public void setSide(int side)
   { PlayModeTable.setSide(side); }

   public int getOurScore()
   { return PlayModeTable.getOurScore(); }

   public int getTheirScore()
   { return PlayModeTable.getTheirScore(); }

   public int getCurrentTime()
   { return PlayModeTable.getCurrentTime(); }

   public int getPlayMode()
   { return PlayModeTable.getPlayMode(); }

   public int getSide()
   { return PlayModeTable.getSide(); }

  //Positionsberechnung: OwnPlayer
   public void setOwnPlayerPosX(double posX)
   { playerTable.playerArray[0].setOwnPlayerPosX(posX); }

   public void setOwnPlayerPosY(double posY)
   { playerTable.playerArray[0].setOwnPlayerPosY(posY); }

   public void setOwnPlayerViewDirection(double viewDirection)
   { playerTable.playerArray[0].setOwnPlayerViewDirection(viewDirection); }

   public double getOwnPlayerPosX()
   { return playerTable.playerArray[0].getOwnPlayerPosX(); }

   public double getOwnPlayerPosY()
   { return playerTable.playerArray[0].getOwnPlayerPosY(); }

   public double getOwnPlayerViewDirection()
   { return playerTable.playerArray[0].getOwnPlayerViewDirection(); }

   //Positionsberechnung: Ball
   public void setBallPosX(double posX)
   { ballTable.ballInfo.setBallPosX(posX); }

   public void setBallPosY(double posY)
   { ballTable.ballInfo.setBallPosY(posY); }

   public void setBallTime(int time)
   { ballTable.ballInfo.setObjectTime(time); }

   public double getBallPosX()
   { return ballTable.ballInfo.getBallPosX(); }

   public double getBallPosY()
   { return ballTable.ballInfo.getBallPosY(); }

   public int getBallTime()
   { return ballTable.ballInfo.getObjectTime(); }

  //Init Nachricht: Nummer
   public void setNumber(int number)
   { playerTable.playerArray[0].setNumber(number); }

   public int getNumber()
   { return playerTable.playerArray[0].getNumber(); }

   //Body Nachrichten
   public void setViewModeQuality(int viewModeQuality)
   { playerTable.playerArray[0].setViewModeQuality(viewModeQuality);
       System.out.println("wm: viewModeQuality" +viewModeQuality);}

   public void setViewModeRange(int viewModeRange)
   { playerTable.playerArray[0].setViewModeRange(viewModeRange); }

   public void setStamina(int stamina)
   { playerTable.playerArray[0].setStamina(stamina);
     System.out.println("stamina: wm" +stamina);}

   public void setEffort(int effort)
   { playerTable.playerArray[0].setEffort(effort); }

   public void setAmountOfSpeed(double amountOfSpeed)
   { playerTable.playerArray[0].setAmountOfSpeed(amountOfSpeed); }

   public void setDirectionOfSpeed(double directionOfSpeed)
   { playerTable.playerArray[0].setDirectionOfSpeed(directionOfSpeed); }

   public void setHeadAngle(double headAngle)
   { playerTable.playerArray[0].setHeadAngle(headAngle); }

   public void setKickCount(int kickCount)
   { playerTable.playerArray[0].setKickCount(kickCount); }

   public void setDashCount(int dashCount)
   { playerTable.playerArray[0].setDashCount(dashCount); }

   public void setTurnCount(int turnCount)
   { playerTable.playerArray[0].setTurnCount(turnCount); }

   public void setSayCount(int sayCount)
   { playerTable.playerArray[0].setSayCount(sayCount); }

   public void setTurnNeckCount(int turnNeckCount)
   { playerTable.playerArray[0].setTurnNeckCount(turnNeckCount); }

   public void setCatchCount(int catchCount)
   { playerTable.playerArray[0].setCatchCount(catchCount); }

   public void setMoveCount(int moveCount)
   { playerTable.playerArray[0].setMoveCount(moveCount); }

   public void setChangeViewCount(int changeViewCount)
   { playerTable.playerArray[0].setChangeViewCount(changeViewCount); }

    public int getViewModeQuality()
   { return playerTable.playerArray[0].getViewModeQuality(); }

   public int getViewModeRange()
   { return playerTable.playerArray[0].getViewModeRange(); }

   public int getStamina()
   { return playerTable.playerArray[0].getStamina(); }

   public int getEffort()
   { return playerTable.playerArray[0].getEffort(); }

   public double getAmountOfSpeed()
   { return playerTable.playerArray[0].getAmountOfSpeed(); }

   public double getDirectionOfSpeed()
   { return playerTable.playerArray[0].getDirectionOfSpeed(); }

   public double getHeadAngle()
   { return playerTable.playerArray[0].getHeadAngle(); }

   public int getKickCount()
   { return playerTable.playerArray[0].getKickCount(); }

   public int getDashCount()
   { return playerTable.playerArray[0].getDashCount(); }

   public int getTurnCount()
   { return playerTable.playerArray[0].getTurnCount(); }

   public int getSayCount()
   { return playerTable.playerArray[0].getSayCount(); }

   public int getTurnNeckCount()
   { return playerTable.playerArray[0].getTurnNeckCount(); }

   public int getCatchCount()
   { return playerTable.playerArray[0].getCatchCount(); }

   public int getMoveCount()
   { return playerTable.playerArray[0].getMoveCount(); }

   public int getChangeViewCount()
   { return playerTable.playerArray[0].getChangeViewCount(); }

  //Flaggen
  public void setFlagDistance(int ID, double distance)
  { flagTable.flagArray[ID].setDistance(distance); }

  public double getFlagDistance(int ID)
  { return flagTable.flagArray[ID].getDistance(); }

  public double getFlagDirection(int ID)
  { return flagTable.flagArray[ID].getDirection(); }

  public double getFlagPosX(int ID)
  { return flagTable.flagArray[ID].getPosX(); }

  public double getFlagPosY(int ID)
  { return flagTable.flagArray[ID].getPosY(); }

  public int getFlagTime(int ID)
  { return flagTable.flagArray[ID].getTime(); }

  public FlagInfo getFlag(int ID)
  { return flagTable.flagArray[ID]; }

  //Linien
  public double getLineDirection(int ID)
  { return lineTable.lineArray[ID].getDirection(); }

   public int getLineTime(int ID)
  { return lineTable.lineArray[ID].getTime(); }

   public LineInfo getLine(int ID)
   { return lineTable.lineArray[ID]; }
}





