/**
 * <p>In dieser Klasse werden directionChange, distanceChange und speedVector
 * gespeichert.</p>
 * @author Alexander Pacnik, Johannes Wechsler
 * @version 2.0
 */

public class DynamicObjectInfo extends FieldObjectInfo
{
//*Field Detail***************************************************************//

   /** Speichert den directionChange eines Objekts.*/
   private double directionChange;

   /** Speichert den distanceChange eines Objekts.*/
   private double distanceChange;

   /** Speichert den speedVevtor eines Objekts.*/
   private double speedVector;

//*Constructor Detail*********************************************************//

   /** Im Konstruktor werden die Attribute auf den default Wert -1000 gesetzt.*/
   public DynamicObjectInfo()
   {
      this.directionChange = -1000;
      this.distanceChange  = -1000;
      this.speedVector     = -1000;
   }

//*Method Detail**************************************************************//

   public void setDirectionChange(double directionChange)
   { this.directionChange = directionChange; }

   public void setDistanceChange(double distanceChange)
   { this.distanceChange = distanceChange; }

   public void setSpeedVector(double speedVector)
   { this.speedVector = speedVector; }

   public double getDirectionChange()
   { return this.directionChange; }

   public double getDistanceChange()
   { return this.distanceChange; }

   public double getSpeedVector()
   { return this.speedVector; }
}