/**
 * <p>In dieser Klasse werden distance, direction und time eines Objektes
 * gespeichert.</p>
 * @author Alexander Pacnik, Johannes Wechsler
 * @version 2.0
 */

public class ObjectInfo
{
//*Field Detail***************************************************************//

   /** Speichert den aktuellen Abstand eines Objektes.*/
   private double distance;

   /** Speichert die aktuellen Richtung eines Objektes.*/
   private double direction;

   /** Speichert die aktuellen Zeit eines Objektes.*/
   protected int time;

//*Constructor Detail*********************************************************//

   /** Hier werden die Attribute mit den Standardwerten 1000 / -1000 gesetzt.*/
   public ObjectInfo()
   {
      this.distance  =  1000;
      this.direction = -1000;
      this.time      = -1000;
   }

//*Method Detail**************************************************************//

   public void setDistance(double distance)
   { this.distance = distance; }

   public void setDirection(double direction)
   { this.direction = direction; }

   public void setTime(int time)
   { this.time = time; }

   public double getDistance()
   { return this.distance;}

   public double getDirection()
   { return this.direction;}

   public int getTime()
   { return this.time;}
}