/**
 * <p>The class defines the characteristics of a flag: flagId. In addition, a
 * flag has the following properties:direction, distance, posX, posY. The left
 * and the right goal are particular flags.</p>
 * @author Alexander Pacnik, Johannes Wechsler
 * @version 1.0
 */

public class FlagInfo extends FieldObjectInfo
{
   // Variablendefinitionen
   protected int ID;

   // Konstruktor
   public FlagInfo(int ID, double distance, double direction, double posX, double posY, int time)
   {
      this.ID = ID;
      this.distance = distance;
      this.direction = direction;
      this.posX = posX;
      this.posY = posY;
      this.time = time;
   }

   // get-Methoden
   public int getID()
   {   return this.ID;   }

   public double getDistance()
   {   return this.distance;   }

   public double getDirection()
   {   return this.direction;   }

   public double getPosX()
   {   return this.posX;   }

   public double getPosY()
   {   return this.posY;   }

   public int getTime()
   {   return this.time;   }

   // set-Methoden
   public void setDistance(double distance)
    { this.distance = distance; }

   public void setDirection(double direction)
   { this.direction = direction; }

   public void setTime(int time)
   { this.time = time; }
}
