import java.util.*;

public class Player extends Thread
{
   public Player(String teamName, int serverport, String servername)
   {
      this.teamName = teamName;
      CommunicationChannel communicationChannel = new CommunicationChannel (servername, serverport);
   }

   public void run()
   {
      EventHandler eventHandler = new EventHandler(communicationChannel);
      // and play
      while (true)
      {
         // receive event - block until one arrives
         eventHandler.event();

         //spielen
         play();

         //visualisieren
         visualize();
      }
   }

   private void play()
   {
   // Start der Taktik/Strategie
   }

   public void visualize()
   {
   // Start der Visualisierung
   }

   public static void main (String[] args)
   {
      //Player player = new Player("localhost", 6000, "Brain");
      Player player = new Player(args[0], Integer.parseInt(args[1]), args[2]);
      player.start();
   }
}
