// To Do: 1. Methoden playerCalculation implementieren und Aufrufe fr SParser festlegen
//        2. Mitspieler und Gegenspieler: Hier weiss ich nicht, welche Informationen man genau bekommt
//           Auch bei den Grossbuchstaben ist mir das nicht ganz klar
//        4. turn_neck funktioniert nicht

import java.util.*;

public class STokenizer
{
   String msg;
   SParser sParser = new SParser();

   //Verarbeitung von see Nachrichten
   public void visualTokenizer(String msg)
   {
      StringTokenizer tokenizer = new StringTokenizer(msg, "()");

      int time = Integer.parseInt(tokenizer.nextToken().substring(4).trim());

      while(tokenizer.hasMoreTokens())                                          //solange noch ein see Objekt existiert
      {
        String code = tokenizer.nextToken();                                    // code: ObjectName

        if (!code.equals(" "))                                                  //to handle see messages without content
         {
            //values: Distance, Direction, DistChange, DirChange, BodyFacingDir, HeadFacingDir
            String values = tokenizer.nextToken();

            //skip next token (whitespace) if possible
            if (tokenizer.hasMoreTokens()) {tokenizer.nextToken();}

            //Convertion of String values to Double Values
            StringTokenizer tokenizerValues = new StringTokenizer(values, " ");
            double [] value = new double [6];

            for (int i=1; tokenizerValues.hasMoreTokens(); i++)
            { value[i] = Double.valueOf(tokenizerValues.nextToken()).doubleValue();}

            //Passing values to SParser

            //Flags
            //Call: sParser.flagCalculation(ID, distance, direction, time)
            if (code.equals("f t l 50")){ sParser.flagCalculation(1, value[1], value[2], time);}
            if (code.equals("f t l 40")){ sParser.flagCalculation(2, value[1], value[2], time);}
            if (code.equals("f t l 30")){ sParser.flagCalculation(3, value[1], value[2], time);}
            if (code.equals("f t l 20")){ sParser.flagCalculation(4, value[1], value[2], time);}
            if (code.equals("f t l 10")){ sParser.flagCalculation(5, value[1], value[2], time);}
            if (code.equals("f t 0"))   { sParser.flagCalculation(6, value[1], value[2], time);}
            if (code.equals("f t r 10")){ sParser.flagCalculation(7, value[1], value[2], time);}
            if (code.equals("f t r 20")){ sParser.flagCalculation(8, value[1], value[2], time);}
            if (code.equals("f t r 30")){ sParser.flagCalculation(9, value[1], value[2], time);}
            if (code.equals("f t r 40")){ sParser.flagCalculation(10, value[1], value[2], time);}
            if (code.equals("f t r 50")){ sParser.flagCalculation(11, value[1], value[2], time);}
            if (code.equals("f r t 30")){ sParser.flagCalculation(12, value[1], value[2], time);}
            if (code.equals("f r t 20")){ sParser.flagCalculation(13, value[1], value[2], time);}
            if (code.equals("f r t 10")){ sParser.flagCalculation(14, value[1], value[2], time);}
            if (code.equals("f r 0"))   { sParser.flagCalculation(15, value[1], value[2], time);}
            if (code.equals("f r b 10")){ sParser.flagCalculation(16, value[1], value[2], time);}
            if (code.equals("f r b 20")){ sParser.flagCalculation(17, value[1], value[2], time);}
            if (code.equals("f r b 30")){ sParser.flagCalculation(18, value[1], value[2], time);}
            if (code.equals("f b r 50")){ sParser.flagCalculation(19, value[1], value[2], time);}
            if (code.equals("f b r 40")){ sParser.flagCalculation(20, value[1], value[2], time);}
            if (code.equals("f b r 30")){ sParser.flagCalculation(21, value[1], value[2], time);}
            if (code.equals("f b r 20")){ sParser.flagCalculation(22, value[1], value[2], time);}
            if (code.equals("f b r 10")){ sParser.flagCalculation(23, value[1], value[2], time);}
            if (code.equals("f b 0"))   { sParser.flagCalculation(24, value[1], value[2], time);}
            if (code.equals("f b l 10")){ sParser.flagCalculation(25, value[1], value[2], time);}
            if (code.equals("f b l 20")){ sParser.flagCalculation(26, value[1], value[2], time);}
            if (code.equals("f b l 30")){ sParser.flagCalculation(27, value[1], value[2], time);}
            if (code.equals("f b l 40")){ sParser.flagCalculation(28, value[1], value[2], time);}
            if (code.equals("f b l 50")){ sParser.flagCalculation(29, value[1], value[2], time);}
            if (code.equals("f l b 30")){ sParser.flagCalculation(30, value[1], value[2], time);}
            if (code.equals("f l b 20")){ sParser.flagCalculation(31, value[1], value[2], time);}
            if (code.equals("f l b 10")){ sParser.flagCalculation(32, value[1], value[2], time);}
            if (code.equals("f l 0"))   { sParser.flagCalculation(33, value[1], value[2], time);}
            if (code.equals("f l t 10")){ sParser.flagCalculation(34, value[1], value[2], time);}
            if (code.equals("f l t 20")){ sParser.flagCalculation(35, value[1], value[2], time);}
            if (code.equals("f l t 30")){ sParser.flagCalculation(36, value[1], value[2], time);}
            if (code.equals("f l t"))   { sParser.flagCalculation(37, value[1], value[2], time);}
            if (code.equals("f c t"))   { sParser.flagCalculation(38, value[1], value[2], time);}
            if (code.equals("f g r t")) { sParser.flagCalculation(40, value[1], value[2], time);}
            if (code.equals("f g r b")) { sParser.flagCalculation(42, value[1], value[2], time);}
            if (code.equals("f r b"))   { sParser.flagCalculation(43, value[1], value[2], time);}
            if (code.equals("f c b"))   { sParser.flagCalculation(44, value[1], value[2], time);}
            if (code.equals("f l b"))   { sParser.flagCalculation(45, value[1], value[2], time);}
            if (code.equals("f g l b")) { sParser.flagCalculation(46, value[1], value[2], time);}
            if (code.equals("f g l t")) { sParser.flagCalculation(48, value[1], value[2], time);}
            if (code.equals("f p r t")) { sParser.flagCalculation(49, value[1], value[2], time);}
            if (code.equals("f p r c")) { sParser.flagCalculation(50, value[1], value[2], time);}
            if (code.equals("f p r b")) { sParser.flagCalculation(51, value[1], value[2], time);}
            if (code.equals("f p l b")) { sParser.flagCalculation(52, value[1], value[2], time);}
            if (code.equals("f p l c")) { sParser.flagCalculation(53, value[1], value[2], time);}
            if (code.equals("f p l t")) { sParser.flagCalculation(54, value[1], value[2], time);}
            if (code.equals("f r t"))   { sParser.flagCalculation(55, value[1], value[2], time);}

            //Linien
            //Call: sParser.lineCalculation(ID, direction)
            if (code.equals("l t")){ sParser.lineCalculation(1, value[1]);}
            if (code.equals("l r")){ sParser.lineCalculation(2, value[1]);}
            if (code.equals("l b")){ sParser.lineCalculation(3, value[1]);}
            if (code.equals("l l")){ sParser.lineCalculation(4, value[1]);}

            //Goals
            //Call: sParser.flagCalculation(ID, distance, direction, time)
            if (code.equals("g l")){ sParser.flagCalculation(41, value[1], value[2], time);}
            if (code.equals("g r")){ sParser.flagCalculation(47, value[1], value[2], time);}

            //Ball
            //Call: sParser.ballCalculation(distance, direction, distChange, dirChange, time)
            if (code.equals("b")){ sParser.ballCalculation(value[1], value[2], value[3], value[4], time);}

            //Objekte, die ausserhalb des Sichtfelds, aber innerhalb von 3 Metern um den Spieler sich befinden,
            //werden ohne Namen erkannt: vgl manual page 30

            //Ball: Normaler Aufruf, da es nur einen Ball gibt
            //Call: sParser.ballCalculation(distance, direction, distChange, dirChange, time)
            if (code.equals("B")){ sParser.ballCalculation(value[1], value[2], value[3], value[4], time);}

            //Flaggen: Nimm die nchste Flagge und aktualisiere deren Information
            //Call: sParser.flagCapitalizedCalculation(distance, direction, time)
            if (code.equals("F")){ sParser.flagCapitalizedCalculation(value[1], value[2], time);}

            //Goal: Nimm das nhere Tor und aktualisiere dessen Information
            //Call: sParser.goalWithoutNameCalculation(distance, direction, time)
            if (code.equals("G")){ sParser.goalCapitalizedCalculation(value[1], value[2], time);}


            //Mitspieler und Gegenspieler
            if (code.startsWith("p"))
            {
               StringTokenizer tokenizerPlayer = new StringTokenizer(code, " ");
               String [] playerStrings = new String [3];

               for (int i=1; tokenizerPlayer.hasMoreTokens(); i++)
               { playerStrings[i] = tokenizerPlayer.nextToken();}

               int team = -1000;
               int number = -1000;
               boolean goalie = false;

               if (playerStrings[0] != null)                                    //team: our = 1; opponent = 2;
               {
                  if (playerStrings[0].equals("ourTeam")) { team = 1;}
                  else { team = 2;}
               }
               //ID: if available, otherwise -1000
               if (playerStrings[1] != null) { number = Integer.parseInt(playerStrings[1]); }
               //goalie: true if goalie, othewise false
               if (playerStrings[2] != null) { goalie = true;}

               //Call: sParser.playerCalculation(team, number, goalie, distance, direction, distChange, dirChange, time)
               sParser.playerCalculation(team, number, goalie, value[1], value[2], value[3], value[4], time);
            }

            //Mitspieler und Gegenspieler
            //Call: sParser.playerCalculation(team, number, goalie, distance, direction, distChange, dirChange, time)
            if (code.equals("P"))
            { sParser.playerCapitalizedCalculation(-1000, -1000, false, value[1], value[2], value[3], value[4], time);}

         }
      }
   }

   //Verarbeitung von init Nachrichten
   public void initTokenizer(String msg)
   {
      StringTokenizer tokenizer = new StringTokenizer(msg, "()");               //Klammern entfernen
      String code = tokenizer.nextToken();

      StringTokenizer tokenizer2 = new StringTokenizer(code, " ");              //Leerzeichen entfernen
      String [] values = new String[4];

      //Initialisierung
      int i = 0;
      int side = -1000;
      int number = -1000;
      int playMode = -1000;

      //Strings abspeichern
      while(tokenizer2.hasMoreTokens())
      {
         values[i] = tokenizer2.nextToken();   // code: ObjectName
         i++;
      }

      //Seite
      if(values[1].equals("l"))
      { side = 1; }
      if(values[1].equals("r"))
      { side = 2; }

      //Nummer
      number = Integer.parseInt(values[2]);

      //Spielstand
      if (values[3].equals("before_kick_off"))
      { playMode = 1; }

      //Call: sParser.initCalculation(side, number, playMode)
      sParser.initCalculation(side, number, playMode);
   }

   //Verarbeitung von sense_body  Nachrichten
   public void bodyTokenizer(String msg)
   {
      StringTokenizer tokenizer = new StringTokenizer(msg, "()");
      int time = Integer.parseInt(tokenizer.nextToken().substring(11).trim());

      String [] values = new String [24];
      int i=0;

      while(tokenizer.hasMoreTokens())
      {
        values[i] = tokenizer.nextToken();
        i++;
      }
      int    viewModeQuality=0;                                                 //high=1 oder low=2
      int    viewModeRange=0;                                                   //narrow=1, normal=2 oder wide=3
      int    stamina=0;
      int    effort=0;
      double amountOfSpeed=0;
      double directionOfSpeed=0;
      double headAngle=0;
      int    kickCount=0;
      int    dashCount=0;
      int    turnCount=0;
      int    sayCount=0;
      int    turnNeckCount=0;
      int    catchCount=0;
      int    moveCount=0;
      int    changeViewCount=0;

      for (i=0;i<24;i++)
      {
         if (values[i] != " " && values[i] != null)
         {
            StringTokenizer tokenizer2 = new StringTokenizer(values[i], " ");
            if(values[i].equals("view_mode high narrow "))
            {
               viewModeQuality = 1;
               viewModeRange = 1;
            }

            if(values[i].equals("view_mode low narrow"))
            {
               viewModeQuality = 2;
               viewModeRange = 1;
            }
            if(values[i].equals("view_mode high normal"))
            {
               viewModeQuality = 1;
               viewModeRange = 2;
            }
            if(values[i].equals("view_mode low normal"))
            {
               viewModeQuality = 2;
               viewModeRange = 2;
            }
            if(values[i].equals("view_mode high wide"))
            {
               viewModeQuality = 1;
               viewModeRange = 3;
            }
            if(values[i].equals("view_mode low wide"))
            {
               viewModeQuality = 2;
               viewModeRange = 3;
            }

            if(values[i].startsWith("stamina"))
            {
               tokenizer2.nextToken();
               String staminaString = tokenizer2.nextToken();
               String effortString = tokenizer2.nextToken();
               stamina = Integer.parseInt(staminaString);
               effort = Integer.parseInt(effortString);
            }
            if(values[i].startsWith("speed"))
            {
               tokenizer2.nextToken();
               String amountOfSpeedString = tokenizer2.nextToken();
               String directionOfSpeedString = tokenizer2.nextToken();
               amountOfSpeed = Double.parseDouble(amountOfSpeedString);
               directionOfSpeed = Double.parseDouble(directionOfSpeedString);
            }
            if(values[i].startsWith("head_angle"))
            {
               tokenizer2.nextToken();
               String headAngleString = tokenizer2.nextToken();
               headAngle = Double.parseDouble(headAngleString);
            }
            if(values[i].startsWith("kick"))
            {
               tokenizer2.nextToken();
               String kickCountString = tokenizer2.nextToken();
               kickCount = Integer.parseInt(kickCountString);
            }
            if(values[i].startsWith("dash"))
            {
               tokenizer2.nextToken();
               String dashCountString = tokenizer2.nextToken();
               dashCount = Integer.parseInt(dashCountString);
            }
            if(values[i].startsWith("turn"))
            {
               tokenizer2.nextToken();
               String turnCountString = tokenizer2.nextToken();
               turnCount = Integer.parseInt(turnCountString);
            }
            if(values[i].startsWith("say"))
            {
               tokenizer2.nextToken();
               String sayCountString = tokenizer2.nextToken();
               sayCount = Integer.parseInt(sayCountString);
            }

            if(values[i].startsWith("turn_neck"))
            {
               while(tokenizer2.hasMoreTokens())
               {
                  tokenizer2.nextToken();
                  String turnNeckCountString = tokenizer2.nextToken();
                  turnNeckCount = Integer.parseInt(turnNeckCountString);
               }
            }

            if(values[i].startsWith("catch"))
            {
               tokenizer2.nextToken();
               String catchCountString = tokenizer2.nextToken();
               catchCount = Integer.parseInt(catchCountString);
            }
            if(values[i].startsWith("move"))
            {
               tokenizer2.nextToken();
               String moveCountString = tokenizer2.nextToken();
               moveCount = Integer.parseInt(moveCountString);
            }
            if(values[i].startsWith("change_view"))
            {
               tokenizer2.nextToken();
               String changeViewCountString = tokenizer2.nextToken();
               changeViewCount = Integer.parseInt(changeViewCountString);
            }
         }
      }

      System.out.println("Umgewandelte Werte:");
      System.out.println("viewModeQuality " +viewModeQuality);
      System.out.println("viewModeRange " +viewModeRange);
      System.out.println("stamina " +stamina);
      System.out.println("effort " +effort);
      System.out.println("amountOfSpeed " +amountOfSpeed);
      System.out.println("directionOfSpeed " +directionOfSpeed);
      System.out.println("headAngle " +headAngle);
      System.out.println("kickCount " +kickCount);
      System.out.println("dashCount " +dashCount);
      System.out.println("turnCount " +turnCount);
      System.out.println("sayCount " +sayCount);
      System.out.println("turnNeckCount " +turnNeckCount);
      System.out.println("catchCount " +catchCount);
      System.out.println("moveCount " +moveCount);
      System.out.println("changeViewCount " +changeViewCount);


      //Call: sParser.bodyCalculation(time, viewModeQuality, viewModeRange, stamina, effort, amoungOfSpeed, directionOfSpeed, headAngle, kickCount, dashCount, turnCount, sayCount, turnNeckCount, catchCount, moveCount, changeViewCount);
      sParser.bodyCalculation(time, viewModeQuality, viewModeRange, stamina, effort, amountOfSpeed, directionOfSpeed, headAngle, kickCount, dashCount, turnCount, sayCount, turnNeckCount, catchCount, moveCount, changeViewCount);
   }

   //Verarbeitung von hear Nachrichten
   public void accusticTokenizer(String msg)
   {
      //Klammern entfernen
      StringTokenizer tokenizer = new StringTokenizer(msg, "()");
      String code = tokenizer.nextToken();

      //Leerzeichen entfernen
      StringTokenizer tokenizer2 = new StringTokenizer(code, " ");
      String [] values = new String[6];

      //Initialisierung
      int i                 = 0;
      int time              = -1000;
      double ballPosX       = -1000;
      double ballPosY       = -1000;
      int playMode          = -1000;
      String sender         = null;
      String hearMessage    = null;
      String valueString    = null;
      String keyWord        = null;
      String playModeString = null;

      //Strings abspeichern
      while((tokenizer2.hasMoreTokens()) && (i<6))
      {
         values[i] = tokenizer2.nextToken();   // code: ObjectName
         i++;
      }

      if ((values[1] != null))
      { time = Integer.parseInt(values[1]); }

      sender = values[2];

      //messages vom referee
      if ((sender != null) && (sender.equals("referee")))
      {
         if (values[3] != null)
         {
            playModeString = values[3];
            if (playModeString.startsWith("goal_l"))
            { playMode = 2; }
            if (playModeString.startsWith("goal_r"))
            { playMode = 1; }
            if ((playModeString.startsWith("foul_l")) || (playModeString.equals("goalie_catch_ball_l")))
            { playMode = 8; }
            if ((playModeString.startsWith("foul_r")) || (playModeString.equals("goalie_catch_ball_r")))
            { playMode = 7; }
            if (playModeString.startsWith("time_up"))
            { playMode = 4; }
            if ((playModeString.equals("half_time")) || (playModeString.equals("time_extended")))
            { playMode = 0; }
         }
      }

      //messages von Mitspielern
      keyWord = values[3];
      if ((keyWord != null) && (keyWord.equals("BALLPOSITION")))
      {
         if ((values[4] != null))
         { ballPosX = Double.parseDouble(values[4]); }
         if ((values[5] != null))
         { ballPosY = Double.parseDouble(values[5]); }
      }

      if (sender.equals("referee") && (playMode != -1000))
      {
         //Call: sParser.hearCalculation(time, playMode)
         sParser.hearCalculation(time, playMode);
      }
      else
      {
         if ((ballPosX != -1000) && (ballPosX != -1000))
         {
            //Call: sParser.hearCalculation(time, ballPosX, ballPosY)
            sParser.hearCalculation(time, ballPosX, ballPosY);
         }
         else
         {
            //Call: sParser.hearCalculation(time)
            sParser.hearCalculation(time);
         }
      }
   }

   //Methode scoreTokenizer:
   //Verarbeitung von score Nachrichten und Aufruf von den entsprechenden
   //SParser Methoden
   public void scoreTokenizer(String msg)
   {
      //Klammern entfernen
      StringTokenizer tokenizer = new StringTokenizer(msg, "()");
      String code = tokenizer.nextToken();

      //Leerzeichen entfernen
      StringTokenizer tokenizer2 = new StringTokenizer(code, " ");
      String [] values = new String[4];

      //Initialisierung
      int i          = 0;
      int time       = -1000;
      int ourScore   = 0;
      int theirScore = 0;

      //Strings abspeichern
      while(tokenizer2.hasMoreTokens())
      {
         values[i] = tokenizer2.nextToken();   // code: ObjectName
         i++;
      }

      if ((values[1] != null))   //time
      { time = Integer.parseInt(values[1]); }
      if ((values[2] != null))   //ourScore
      { ourScore   = Integer.parseInt(values[2]); }
      if ((values[3] != null))   //theirScore
      { theirScore = Integer.parseInt(values[3]); }

      //Call: sParser.scoreCalculation(time, ourScore, theirScore)
      sParser.scoreCalculation(time, ourScore, theirScore);
   }
}

